/* application source */
var userInFront = false;

var vid1 = document.getElementById("vid1"); 
var vid1Playing = false;
var vid2 = document.getElementById("vid2"); 
var vid2Playing = false;
var vid3 = document.getElementById("vid3"); 
var vid3Playing = false;

var canvas = document.getElementById("skeletonsCanvas");
var context = canvas.getContext("2d");

var videoActive = false;
 
function getSkeletons(jsonObject){
  
  
  
  if (context == null) {
      return;
  }
  try{
    if(recorder.recording){
      recorder.saveStep(jsonObject);
    }
  }catch(err){
  
  }
  
  context.clearRect(0, 0, canvas.width, canvas.height);

  for (var i = 0; i < jsonObject.skeletons.length; i++) {
	var headZ = 0;
    var hipZ = 0;

    //draw head
    var head = jsonObject.skeletons[i].joints[6];
    
    //http://www.codeproject.com/KB/dotnet/KinectGettingStarted/7.png
  //------------------------
  //[0] handright
  //[1] elbowright
  //[2] shoulderright
  //[3] handleft
  //[4] elbowleft
  //[5] shoulderleft
  //[6] head
  //[7] spineneck
  //[8] spinecenter
  //[9] hipcenter
  //[10] kneeleft
  //[11] kneeright
  //[12] ankleleft
  //[13] ankleright
    
    var shouldercenter = jsonObject.skeletons[i].joints[7];
    var shoulderleft = jsonObject.skeletons[i].joints[5];
    var shoulderright = jsonObject.skeletons[i].joints[2];
    var elbowright = jsonObject.skeletons[i].joints[1];
    var elbowleft = jsonObject.skeletons[i].joints[4];
    var handright = jsonObject.skeletons[i].joints[0];
    var handleft = jsonObject.skeletons[i].joints[3];
    //var wristright = jsonObject.skeletons[i].joints[10];
    //var wristleft = jsonObject.skeletons[i].joints[6];
    var hipcenter = jsonObject.skeletons[i].joints[9];
    var kneeleft = jsonObject.skeletons[i].joints[10];
    var kneeright = jsonObject.skeletons[i].joints[11];    
    var ankleleft = jsonObject.skeletons[i].joints[12];    
    var ankleright = jsonObject.skeletons[i].joints[13];    
    
    $("#xval").html(head.x + "," + head.z);
    
$("#xval").html(head.x + "," + head.z);
    
    if(!videoActive && (head.x > 45 && head.x < 320) && (head.z > 2.90 && head.z < 3.5))
    {
    	showButtons();
    }
    else if(!videoActive &&  !((head.x > 45 && head.x < 320) && (head.z > 2.90 && head.z < 3.5)))
    {
    	hideVideos();
    }
    
    
    
    context.fillStyle = "#999999";
    context.strokeStyle = '#999999'; 
    context.lineWidth = 15;
	
    
    context.beginPath()
    context.arc(head.x, head.y, 20, 0, Math.PI * 2, true);
    context.closePath()
    context.fill();	
    context.stroke(); 
    
    context.beginPath()
   	context.moveTo(head.x, head.y);
	context.lineTo(shouldercenter.x, shouldercenter.y);
    context.closePath()
    context.stroke(); 

    
    context.beginPath()
   		context.moveTo(shouldercenter.x, shouldercenter.y);
		context.lineTo(elbowright.x, elbowright.y);	    
    context.closePath()
    context.stroke(); 

   context.beginPath()
   		context.moveTo(elbowright.x, elbowright.y);
		context.lineTo(handright.x, handright.y);	    
    context.closePath()
    context.stroke(); 

    
   context.beginPath()
    	context.moveTo(shouldercenter.x, shouldercenter.y);
    	context.lineTo(elbowleft.x, elbowleft.y);
    context.closePath()
    context.stroke(); 

    context.beginPath()
   		context.moveTo(elbowleft.x, elbowleft.y);
		context.lineTo(handleft.x, handleft.y);	    
    context.closePath()
    context.stroke(); 
    
    context.beginPath()
    	context.moveTo(shouldercenter.x, shouldercenter.y);
    	context.lineTo(hipcenter.x, hipcenter.y);
    context.closePath()
    context.stroke(); 

    context.beginPath()
    	context.moveTo(hipcenter.x, hipcenter.y);
    	context.lineTo(kneeleft.x, kneeleft.y);    
    context.closePath()
    context.stroke(); 

    context.beginPath()
    	context.moveTo(kneeleft.x, kneeleft.y);
    	context.lineTo(ankleleft.x, ankleleft.y);    
    context.closePath()
    context.stroke(); 
    
    
    context.beginPath()
    	context.moveTo(hipcenter.x, hipcenter.y);
    	context.lineTo(kneeright.x, kneeright.y);    
     context.closePath()
    context.stroke(); 

    context.beginPath()
    	context.moveTo(kneeright.x, kneeright.y);
    	context.lineTo(ankleright.x, ankleright.y);    
    context.closePath()
    context.stroke(); 

    
    
    

    /*
    context.beginPath()
    context.arc(shoulderLeft.x, shoulderLeft.y, 20, 0, Math.PI * 2, true);
    context.closePath()
    context.fill();	
    context.stroke(); 
    
    context.beginPath()
    context.arc(shoulderRight.x, shoulderRight.y, 20, 0, Math.PI * 2, true);    
    context.closePath()
    context.fill();	
    context.stroke(); 

	*/
    
    
    
    
    /*for (var j = 0; j < jsonObject.skeletons[i].joints.length; j++) 
    {
      var joint = jsonObject.skeletons[i].joints[j];

      context.fillStyle = "#EC8B38";
      context.beginPath();
      context.arc(joint.x, joint.y, 10, 0, Math.PI * 2, true);
      context.closePath();
      context.fill();	
      
     }*/
	}
}

function showButtons()
{
  $('#videoArea').show();
  $('#vidButtons').show();
  $('#mycursor').show();
	
}


function hideViewer()
{
	$('#container').html("");
}


function sendVideo(vidIdx)
{
  videoActive = true;
  
  $('#vidButtons').hide();
  $('#mycursor').hide();
  
  switch(vidIdx)
  {
    case 1:
      vid2.pause();
      $('#vid2').hide();
      vid3.pause();
      $('#vid3').hide();

      vid1.load();
      vid1.play();
      $('#vid1').show();
      vid1Playing = true;
      vid2Playing = false;
      vid3Playing = false;
      break;
    case 2:
      vid1.pause();
      $('#vid1').hide();
      vid3.pause();
      $('#vid3').hide();

      vid2.load();
      vid2.play();
      $('#vid2').show();
      vid2Playing = true;
      vid1Playing = false;
      vid3Playing = false;
      break;
    case 3:
      vid1.pause();
      $('#vid1').hide();
      vid2.pause();
      $('#vid2').hide();

      vid3.load();
      vid3.play();
      $('#vid3').show();
      vid3Playing = true;
      vid1Playing = false;
      vid2Playing = false;
      break;
  }
}


function hideVideos()
{

  vid1.pause();
  $('#vid1').hide();
  vid2.pause();
  $('#vid2').hide();
  vid3.pause();
  $('#vid3').hide();

  $('#videoArea').hide();
  $('#mycursor').hide();
  $("#xval").hide();
  videoActive = false;
}



function msgFromArduino(value){
	console.debug('From Arduino: ' + value);
}

function next() {
	console.debug('Next!');  
}

function prior() {
	console.debug('Prior');
}

function grip() {
	console.debug('Grip!');  
}

function release() {
	console.debug('Release');
}

function noUser(){
  hideViewer();
  console.debug('No User :(');  
//sendToArduino('0');
  
}

function newUser() {
  //showButtons();
  console.debug('New User :)');  

}

function changeHandNone() {
	console.debug('Hand None');  
}

function changeHandRight() {
  	console.debug('Hand Right');  
}

function changeHandLeft() {
	console.debug('Hand Left');  
}

/**
* Update Quiz results on the current slide.
* @param int qzid Quiz ID
* @author Hjalmar Guerra
*/
function getAnswers(qzid){
    //Get json of values from server
    $.ajax({
        type: "GET",
        dataType: "json",
        url: "http://xlic.es/apirest/quiz/answers",
        data: {'id': qzid },
        async: true,
        success: function(data) {
            //console.log(data);  
            displayData(data);
        }
    });    
}

function startVideos(){
  userInFront = false;
  
    vid1.pause();
    $('#vid1').hide();
	vid2.pause();
    $('#vid2').hide();
    vid3.pause();
    $('#vid3').hide();
  
    vid1Playing = false;  
    vid2Playing = false;
    vid3Playing = false;
  
  vid1.onended = function() {
   hideVideos();
};
  
  vid2.onpause = function() {
   hideVideos();
};
  
  
  vid3.onended = function() {
   hideVideos();
};
}




	    $(function(){
          ubiquo.load();
		startVideos();
	    });



//Clases de control:
/*
 * Ubi---click
 * Ubi---leftclick
 * Ubi---rightclick
 * 
 */

ubiquo = function(){
    var controls ={
	click:"Ubi---click",
	loaded:"Ubi---loaded"
    };

    var cursorInterval;
    var cursorIntervalWidth=0;
    var cursorStart = function(){
	var LoadingExists = document.getElementById("ubiCursorLoading");

	if(LoadingExists===null){
	    var body  = document.getElementsByTagName("body").item(0);
	    var myDiv= document.createElement("div");
	    myDiv.id="ubiCursorLoading";
	    myDiv.style.position="fixed";
	    myDiv.style.bottom="0px";
	    myDiv.style.right="0px";
	    myDiv.style.width="0px";
	    myDiv.style.height="20px";
      myDiv.style.zIndex="99999";
	    myDiv.style.backgroundColor="green";

	    body.appendChild(myDiv);
	}
	cursorInterval = setInterval(function(){
	    cursorIntervalWidth+=1;
	    var LoadingExists = document.getElementById("ubiCursorLoading");
	    LoadingExists.style.width=cursorIntervalWidth+"px";
	    
	},20);
	
    };
    
    var cursorEnd = function(){
	var LoadingExists = document.getElementById("ubiCursorLoading");
	cursorIntervalWidth=0;
	clearTimeout(cursorInterval);
	LoadingExists.style.width=cursorIntervalWidth+"px";
	
    };
    
    
    
    var hasClass= function (element, cls) {
	return (' ' + element.className + ' ').indexOf(' ' + cls + ' ') > -1;
    };
    
    var prepareClick = function(element){	
	cursorStart();
	this.ubiready = setTimeout(function(that){
	    return function(){
		var eventReturn = new Event("click");
		that.dispatchEvent(eventReturn);
		cursorEnd();
	    };
	}(this),2000);
    };
    
  
    
    var loadMouseOver = function(element){

	element.addEventListener("mouseover",function(){
	    prepareClick.apply(this);
	});
	element.addEventListener("mouseout",function(){
	    clearTimeout(this.ubiready);
	    cursorEnd();
	});
    };
    
    var initEvent = function(elements){
	for (var i in elements){
	    if(!hasClass(elements[i],controls.loaded) && typeof elements[i] ==="object"){
		elements[i].className = elements[i].className + " " +controls.loaded;
		loadMouseOver(elements[i]);
	    }
	}
    };
    
    var load = function(){
	var elementCollection = document.getElementsByClassName(controls.click);
	initEvent(elementCollection);
    };
    
    return{
	load:load
    };
    
}();


  (function ($) {

        $.fn.mySlider = function () {
            $('#mycursor').show();
            $('#mycursor').css("background-image", "url('http://www.clker.com/cliparts/L/a/9/2/H/N/pointer-hand-mouse-hi.png')");
            $('body').mousemove(function (e) {
            $('#mycursor').css('left', e.clientX - 20).css('top', e.clientY + 7);

            });

        };
    }(jQuery));

    $(document).ready(function () {
        $("body").mySlider();

        //showIntroVideo();

        
    });


